import java.io.*;
String result;

void DO_CCX() {
  try {

    Runtime r = Runtime.getRuntime();
    //    println("ccx "+filename);
    String [] command  = {
      batchfiledir, "ccx", workdir+filename
    };
    Process process =  Runtime.getRuntime().exec(command);   
    InputStream is = process.getInputStream();

    InputStreamReader isr = new InputStreamReader(is);
    BufferedReader br = new BufferedReader(isr);
    while ( (result = br.readLine ()) != null) {
      //      System.out.println(result);
    }
  } 
  catch (IOException ex) {
    ex.printStackTrace();
  }
}

void DO_CGX() {
  try {

    Runtime r = Runtime.getRuntime();
    //    println("cgx "+filename);
    String [] command  = {
      batchfiledir, "cgx", "-v", workdir+filename+".frd"
    };
    Process process =  Runtime.getRuntime().exec(command);


    InputStream is = process.getInputStream();


    InputStreamReader isr = new InputStreamReader(is);
    BufferedReader br = new BufferedReader(isr);
    while ( (result = br.readLine ()) != null) {
      //      System.out.println(result);
    }
  } 
  catch (IOException ex) {
    ex.printStackTrace();
  }
}


void LOAD_CCX() {
  String[] m1;

  mises = new String[1000000];
  for (int qw=0; qw<mises.length; qw++) {
    mises[qw]="";
  }
  mp= new double[blocks*blocks*blocks];
  for (int qww=0; qww<mp.length; qww++) {
    mp[qww]=0;
  }

  mises = loadStrings(workdir+filename+".dat");
  int ij=0;
  for (ij=0; ij<mises.length; ij++) {
    m1 = match(mises[ij], "stresses");
    if (m1 != null) { 
      break;
    }
  } 
  //println(ij);
  int startline = ij+2;
  float ppmin = 1000000;
  float ppmax = 0;
  int pnum = 0;
  float sxx = 0;
  float syy = 0;
  float szz = 0;
  float sxy = 0;
  float sxz = 0;
  float syz = 0;

  // println(mises[startline+8000]);

  ij=startline; 
  while (match (mises[ij+9], "strains")==null) {
    ij=ij+1;
    float startnum = 0;
    for (int ijj=0; ijj<8; ijj++) {
      String[] p = splitTokens(mises[ij+ijj]);
      //println(ij-startline); 
      //println(ijj);
      //println(ij+ijj - startline);
      //println("---------------");
      //println(p);
      //sxx,syy,szz,sxy,sxz,syz
      pnum = int(p[0]);
      sxx = float(p[2]);
      syy = float(p[3]);
      szz = float(p[4]);
      sxy = float(p[5]);
      sxz = float(p[6]);
      syz = float(p[7]);

      startnum = startnum + sqrt(0.5*((sxx-syy)*(sxx-syy)+(syy-szz)*(syy-szz)+(szz-sxx)*(szz-sxx)+3*(sxy*sxy+sxz*sxz+sxy*sxy+syz*syz+sxz*sxz+syz*syz)));
    }
    if (pnum == 1) { 
      ppmin = startnum; 
      ppmax = startnum;
    }

    if (startnum < ppmin && startnum > 0.0 && p[pnum-1].getstate() == 1) { 
      ppmin = startnum;
    }
    if (startnum > ppmax && p[pnum-1].getstate() == 1) { 
      ppmax = startnum;
    }

    if ( p[pnum-1].getstate() == 1) {
      mp[pnum-1] = startnum;
    } 
    else {
      mp[pnum-1] = -1;
    }
  }


  //println("mp+ "+mp);
  double abc;
  double upper, lower;
  for (int iijj=0; iijj<mp.length; iijj++) {


    upper = mp[iijj]-ppmin;
    lower = ppmax-ppmin;
    abc =  upper / lower;

    //  println(mp[iijj]+" --- "+ abc);
    //        if( mp[iijj] == ppmax ) { println ("***** max ****** "+ppmax); }
    //        if( mp[iijj] == ppmin ) { println ("***** min ****** "+ppmin); }



    if ( mp[iijj] != 0.0) {
      // absolutely
      p[iijj].setmag((float)mp[iijj]*100000);
      // relatively
      //  p[iijj].setmag((float)abc * 100* 255);  
      //println(mp[iijj] + "..." + upper + " /// " + lower + " === "+(float)abc * 100 );
    } 
    else {
      p[iijj].setmag(0.0);
    }
  }
}


int REMOVE() {
  int removenum = 0;

  int nnum=0;
  for ( int k=0; k<blocks; k++) { 
    for (int j=0; j<blocks; j++) { 
      for (int i=0; i<blocks; i++) {      
        if (  p[nnum].magvalue < THRESHOLD_MIN && p[nnum].getstate() ==1) {               
          p[nnum].setstate(2);
          removenum = removenum + 1;
        } 
        nnum=nnum+1;
      }
    }
  }

  return removenum;
}


int GROWTH() {

  int GROWTHresultnum = 0;

  for (int u=0; u<GROWTHnum.length; u++) { 
    GROWTHnum[u]=-1;
  }

  int currentNum = 0;
  int tempPotential;
  float lambda = 0.9;
  for ( int k=0; k<blocks; k++) { 
    for (int j=0; j<blocks; j++) { 
      for (int i=0; i<blocks; i++) {      
        currentNum = i+blocks*j+(blocks*blocks)*k;
        tempPotential = 0;
        if (k>0        && p[i+blocks*j+(blocks*blocks)*(k-1)].getstate() != 2 && p[i+blocks*j+(blocks*blocks)*(k-1)].magvalue > THRESHOLD_MAX) { 
          tempPotential++;
        }
        if (k<blocks-1 && p[i+blocks*j+(blocks*blocks)*(k+1)].getstate() != 2 && p[i+blocks*j+(blocks*blocks)*(k+1)].magvalue > THRESHOLD_MAX) { 
          tempPotential++;
        }
        if (j>0        && p[i+blocks*(j-1)+(blocks*blocks)*k].getstate() != 2 && p[i+blocks*(j-1)+(blocks*blocks)*k].magvalue > THRESHOLD_MAX) { 
          tempPotential++;
        }
        if (j<blocks-1 && p[i+blocks*(j+1)+(blocks*blocks)*k].getstate() != 2 && p[i+blocks*(j+1)+(blocks*blocks)*k].magvalue > THRESHOLD_MAX) { 
          tempPotential++;
        }
        if (i>0        && p[(i-1)+blocks*j+(blocks*blocks)*k].getstate() != 2 && p[(i-1)+blocks*j+(blocks*blocks)*k].magvalue > THRESHOLD_MAX) { 
          tempPotential++;
        }
        if (i<blocks-1 && p[(i+1)+blocks*j+(blocks*blocks)*k].getstate() != 2 && p[(i+1)+blocks*j+(blocks*blocks)*k].magvalue > THRESHOLD_MAX) { 
          tempPotential++;
        }
        if (p[currentNum].getstate() != 2 && p[currentNum].magvalue < THRESHOLD_MIN) {
          tempPotential--;
        }    
        p[currentNum].potential = tempPotential;//lambda*p[currentNum].potential + tempPotential;
      }
    }
  }

  for (int u=0; u<p.length; u++) { 
    if (p[u].potential > 0 && p[u].getstate() == 2) {
      p[u].setstate(1); 
      GROWTHresultnum = GROWTHresultnum + 1;
    }
    else if (p[u].potential <= 0 && p[u].getstate() == 1) {
      p[u].setstate(2); 
      GROWTHresultnum = GROWTHresultnum + 1;
    }
  }
  numberOfSteps++;
  return GROWTHresultnum;
}


void WRITE_INP() {

  int linee=0;
  st = new String[1000000]; 
  for (int qq=0; qq<st.length; qq++) {
    st[qq]="";
  }

  st[linee] = "*node,NSET=NALL";
  linee = linee+1; 
  int nnum=1;
  for ( int i=0; i<blocks+1; i++) { 
    for (int j=0; j<blocks+1; j++) { 
      for (int k=0; k<blocks+1; k++) {            
        st[linee] = nnum + "," + k*gridLength +","+j*gridLength+","+i*gridLength;
        nnum=nnum+1;       
        linee=linee+1;
      }
    }
  }

  st[linee] = "*element,TYPE=C3D8,Elset=EALL";
  linee = linee+1;

  nnum=1;
  int dd = 0;
  for ( int i=0; i<blocks; i++) { 
    for (int j=0; j<blocks; j++) { 
      for (int k=0; k<blocks; k++) {      

        if (p[k+j*blocks+i*blocks*blocks].getstate() != 2) {
          dd = 1+k+j*(blocks+1)+i*(blocks+1)*(blocks+1);
          st[linee] = nnum + "," + int(dd) + ","+ int(dd+1) + "," + int(dd+(blocks+2)) + "," +int(dd+(blocks+1)) + "," + int(dd+(blocks+1)*(blocks+1)) + ","+ int(dd+(blocks+1)*(blocks+1)+1) + "," + int(dd+(blocks+1)*(blocks+1)+(blocks+2)) +","+ int(dd+(blocks+1)*(blocks+1)+(blocks+1));
          linee=linee+1;
        }
        nnum=nnum+1;
      }
    }
  }

  float density = 0.9;

  st[linee] = "*MATERIAL, Name=mat1";
  linee = linee+1;
  st[linee] = "*DENSITY";
  linee = linee+1;
  st[linee] = density + "";
  linee = linee+1;
  st[linee] = "*ELASTIC";
  linee = linee+1;
  st[linee] = elastic01 + "," + elastic02;
  linee = linee+1;
  st[linee] = "*SOLID SECTION, Elset=EALL, Material=mat1";
  linee = linee+1;
  st[linee] = "*STEP";
  linee = linee+1;
  st[linee] = "*STATIC";
  linee = linee+1;
  st[linee] = "*boundary";
  linee = linee+1;

  for ( int i=0; i<blocks; i++) { 
    for (int j=0; j<blocks; j++) { 
      for (int k=0; k<blocks; k++) { 

        if (p[k+j*blocks+i*(blocks)*(blocks)].getstate() == 9) {
          dd = 1+k+j*(blocks+1)+i*(blocks*blocks+1);
          //   st[linee] = nnum + "," + int(dd) + ","+ int(dd+1) + "," + int(dd+12) + "," +int(dd+11) + "," + int(dd+121) + ","+ int(dd+122) + "," + int(dd+133) +","+ int(dd+132);

          st[linee] = int(dd)+",1,3";              
          linee=linee+1;
          st[linee] = int(dd+1)+",1,3";              
          linee=linee+1;
          st[linee] = int(dd+(blocks+1)+1)+",1,3";              
          linee=linee+1;
          st[linee] = int(dd+(blocks+1))+",1,3";              
          linee=linee+1;
          st[linee] = int(dd+(blocks+1)*(blocks+1))+",1,3";              
          linee=linee+1;
          st[linee] = int(dd+(blocks+1)*(blocks+1)+1)+",1,3";              
          linee=linee+1;
          st[linee] = int(dd+(blocks+1)*(blocks+1)+(blocks+1)+1)+",1,3";              
          linee=linee+1;
          st[linee] = int(dd+(blocks+1)*(blocks+1)+(blocks+1))+",1,3";              
          linee=linee+1;
        }
      }
    }
  }

  st[linee] = "*CLOAD";
  linee = linee+1;
  int sw = 0;
  double spal = 0;
int tmp = 50*50;
  for ( int i=0; i<blocks; i++) { 
    for (int j=0; j<blocks; j++) { 
      for (int k=0; k<blocks; k++) {      

        sw= 0;
        if (p[k+j*(blocks)+i*blocks*blocks].getstate() == 3) { 
          sw = 1; 
          spal = BURDEN/tmp;
        }
        if (p[k+j*(blocks)+i*blocks*blocks].getstate() == 4) { 
          sw = 1; 
          spal = -BURDEN/tmp;
        }
        if (p[k+j*(blocks)+i*blocks*blocks].getstate() == 5) { 
          sw = 2; 
          spal = BURDEN/tmp;
        }      
        if (p[k+j*(blocks)+i*blocks*blocks].getstate() == 6) { 
          sw = 2; 
          spal = -BURDEN/tmp;
        } 
        if (p[k+j*(blocks)+i*blocks*blocks].getstate() == 7) { 
          sw = 3; 
          spal = BURDEN/tmp;
        }      
        if (p[k+j*(blocks)+i*blocks*blocks].getstate() == 8) { 
          sw = 3; 
          spal = -BURDEN/tmp;
        }   

        if (sw != 0) {
          dd = 1+k+j*(blocks+1)+i*(blocks+1)*(blocks+1);
          st[linee] = int(dd)+","+sw+","+spal;
          linee = linee+1;
          st[linee] = int(dd+1)+","+sw+","+spal;
          linee = linee+1;
          st[linee] = int(dd+(blocks+1)+1)+","+sw+","+spal;
          linee = linee+1;
          st[linee] = int(dd+(blocks+1))+","+sw+","+spal;
          linee = linee+1;
          st[linee] = int(dd+(blocks+1)*(blocks+1))+","+sw+","+spal;
          linee = linee+1;
          st[linee] = int(dd+(blocks+1)*(blocks+1)+1)+","+sw+","+spal;
          linee = linee+1;
          st[linee] = int(dd+(blocks+1)*(blocks+1)+(blocks+1)+1)+","+sw+","+spal;
          ;
          linee = linee+1;
          st[linee] = int(dd+(blocks+1)*(blocks+1)+(blocks+1))+","+sw+","+spal;
          linee = linee+1;
        }
      }
    }
  }



  st[linee] = "*NODE FILE";
  linee = linee+1;
  st[linee] = "U";
  linee = linee+1;
  st[linee] = "*EL FILE";
  linee = linee+1;
  st[linee] = "S,E";
  linee = linee+1;
  st[linee] = "*NODE PRINT, NSET=NALL";
  linee = linee+1;
  st[linee] = "U";
  linee = linee+1;
  st[linee] = "*EL PRINT, ELSET=EALL";
  linee = linee+1;
  st[linee] = "S,E";
  linee = linee+1;
  st[linee] = "*END STEP";

  filename = "test1";// year()+"_"+month()+"_"+day()+"_"+hour()+"_"+minute()+"_"+second();
  saveStrings(workdir+filename+".inp", st);
  //println(workdir+filename+".inp");
}

void STOP() {
  evolution = false;
}

void AUTO() {
  WRITE_INP();
  DO_CCX();
  LOAD_CCX();
}

void EVOLVE() {

  evolution = true;
}

int DOEVOLUTION() {
  WRITE_INP();
  DO_CCX();
  LOAD_CCX();

  //int evor = REMOVE();
  int evorr = GROWTH();
  return  evorr;
}





